//Tool_Omniwrench
datablock AudioProfile(OmniwrenchDrawSound)
{
   filename    = "./OmniwrenchDraw.wav";
   description = AudioClosest3d;
   preload = true;
};


datablock ExplosionData(OmniwrenchExplosion)
{
   lifeTimeMS = 300;

   soundProfile = SwordHitSound;

   particleEmitter = SwordExplosionEmitter;
   particleDensity = 8;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "12.0 14.0 12.0";
   camShakeAmp = "0.7 0.7 0.7";
   camShakeDuration = 0.35;
   camShakeRadius = 7.0;

   lightStartRadius = 1.5;
   lightEndRadius = 0;
   lightStartColor = "0.0 0.0 2.0";
   lightEndColor = "0 0 0";
};

datablock ItemData(OmniwrenchItem : swordItem)
{
	shapeFile = "./Omniwrench.dts";
	uiName = "Omniwrench";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	image = OmniwrenchImage;
	canDrop = true;
	iconName = "./icon_Omniwrench";
};

AddDamageType("Omniwrench",   '<bitmap:add-ons/Tool_Omniwrench/CI_Omniwrench> %1',    '%2 <bitmap:add-ons/Tool_Omniwrench/CI_Omniwrench> %1',0.75,1);

datablock ProjectileData(OmniwrenchProjectile)
{
   directDamage      = 20;
   directDamageType  = $DamageType::Omniwrench;
   radiusDamageType  = $DamageType::Omniwrench;
   explosion         = OmniwrenchExplosion;

   muzzleVelocity      = 65;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Omniwrench Hit";
};

datablock ShapeBaseImageData(OmniwrenchImage)
{
   shapeFile = "./Omniwrench.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";

   correctMuzzleVector = false;

   className = "WeaponImage";

   item = OmniwrenchItem;
   ammo = " ";
   projectile = OmniwrenchProjectile;
   projectileType = Projectile;


   melee = true;
   doRetraction = false;

   armReady = true;


   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = OmniwrenchDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	stateSequence[3]		 = "Extend";
	//stateTransitionOnTriggerUp[3]	= "StopFire";

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function OmniwrenchImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function OmniwrenchImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}
function OmniwrenchProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
	if(%col.getClassName() $= "fxDTSBrick")
	{
		$InputTarget_["Self"] = %col;
		$InputTarget_["Player"] = %obj.client.player;
		$InputTarget_["Client"] = %obj.client;
		if($Server::LAN)
		{
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);
		}
		else
		{
			if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))
			{
				$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);
			}
			else
			{
				$InputTarget_["MiniGame"] = 0;
			}
		}
		%col.processInputEvent(OnOmniwrenchHit,%obj.client);
	}
}